#ifndef FREERTOS_ISR_H
#define FREERTOS_ISR_H

#if defined(__CCRL__)

extern void vPortFreeRTOSInterruptCommonHandler_C(void);

#pragma inline_asm vPortFreeRTOSInterruptCommonHandler_C_Helper

static void __near vPortFreeRTOSInterruptCommonHandler_C_Helper(void)
{
    pop bc
#if defined(__RL78_SMALL__)
    br !_vPortFreeRTOSInterruptCommonHandler_C
#elif defined(__RL78_MEDIUM__)
    br !!_vPortFreeRTOSInterruptCommonHandler_C
#else
    #error Unknown memory model.
#endif
}

#define R_PRAGMA_FREERTOS_INTERRUPT(function) \
    static void __near _##function(void); \
    void __near function(void) \
    { \
        /* vPortFreeRTOSInterruptCommonHandler_C() will not return here. */ \
        void (__near * volatile p)() = _##function; \
        vPortFreeRTOSInterruptCommonHandler_C_Helper(); \
        /* The following is intended to remove the epilogue code. */ \
        while (1) {} \
    }

#elif defined(__GNUC__)

extern void vPortFreeRTOSInterruptCommonHandler_C(void);

#define R_PRAGMA_FREERTOS_INTERRUPT(function) \
    void _##function(void); \
    void function(void) __attribute__((interrupt, noreturn)); \
    void function(void) \
    { \
        /* vPortFreeRTOSInterruptCommonHandler_C() will not return here. */ \
        __asm volatile \
        ( \
            "movw bc, #__" #function "\n" \
            "br !!_vPortFreeRTOSInterruptCommonHandler_C\n" \
        ); \
        /* The following is intended to remove the epilogue code. */ \
        while (1) {} \
    } \

#endif

#endif
